### A free/open-source library for quantitative finance

Public Member Functions | Protected Member Functions | Protected Attributes
HaganPricer Class Reference

CMS-coupon pricer. More...

`#include <ql/cashflows/conundrumpricer.hpp>`

Inheritance diagram for HaganPricer:
[legend]

List of all members.

## Public Member Functions

virtual Real | swapletPrice () const =0
virtual Rate | swapletRate () const
virtual Real | capletPrice (Rate effectiveCap) const
virtual Rate | capletRate (Rate effectiveCap) const
virtual Real | floorletPrice (Rate effectiveFloor) const
virtual Rate | floorletRate (Rate effectiveFloor) const
Real | meanReversion () const
void | setMeanReversion (const Handle< Quote > &meanReversion)

## Protected Member Functions

| HaganPricer (const Handle< SwaptionVolatilityStructure > &swaptionVol, GFunctionFactory::YieldCurveModel modelOfYieldCurve, const Handle< Quote > &meanReversion)
void | initialize (const FloatingRateCoupon &coupon)
virtual Real | optionletPrice (Option::Type optionType, Real strike) const =0

## Protected Attributes

boost::shared_ptr < YieldTermStructure > | rateCurve_
GFunctionFactory::YieldCurveModel | modelOfYieldCurve_
boost::shared_ptr< GFunction > | gFunction_
const CmsCoupon * | coupon_
Date | paymentDate_
Date | fixingDate_
Rate | swapRateValue_
DiscountFactor | discount_
Real | annuity_
Real | gearing_
Spread | spread_
Real | spreadLegValue_
Rate | cutoffForCaplet_
Rate | cutoffForFloorlet_
Handle< Quote > | meanReversion_
Period | swapTenor_
boost::shared_ptr < VanillaOptionPricer > | vanillaOptionPricer_

## Detailed Description

CMS-coupon pricer.

Base class for the pricing of a CMS coupon via static replication as in Hagan's "Conundrums..." article